<?php
//Fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
$ESIA_WIDGET_NOTREE=TRUE;
include_once $path.'common.php';
$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_PLAN');
$apache_path = $arr[0]['apache_path'];
$foldersURL = $apache_path . 'folder_plan.php';
include_once $path.'/'.$apache_path.'plan.conf.php';
include_once MODEL_PLAN;
try
{
	//vérification des accès
	if($user->getDroits($dbconnection,"map_view") == 1)
	{
		$smarty->assign('apache_path', $apache_path);
		//mise en place des fichier de langue
		if($user->getLang()!="")
		{
			//configuration de la langue de l'application
			include $path.'/'.$apache_path.'/lang/'.$user->getLang().'.php';
		}
		else
		{
			include $path.'/'.$apache_path.'/lang/'.LANG.'.php';
			include_once $path.'/theme/default/icons.php';
		}
		if(empty($user->getTheme()))
		{
			include_once $path.'/theme/default/icons.php';
		}
		else 
		{
			include_once $path.'/theme/'.$user->getTheme().'/icons.php';
		}
		$smarty->assign('lang', $lang);
		if(isset($_GET['action']))
		{
			$action=$_GET['action'];
		}
		else
		{
			$action='menu';
		}
		$user_have_admin_perm = ($user->getDroits($dbconnection,"map_administration") == 1 );
		$smarty->assign('plan_admin_perm',$user_have_admin_perm);

		$smarty->assign('webp_plan_name', $arr[0]['name']);

		if($action == 'folder')
		{
			// Recupération des éléments a afficher dans le dossier
			$content = array();
			$folderId = 0; // 0 for Root folder
			if(!empty($_GET['id']))
			{
				$folderId = intval($_GET['id']);
			}
			$folders = Model_plan::getFolders($dbconnection, $user->getId(), NULL, $folderId);
			$plans = Model_plan::getPlans($dbconnection, $user->getId(), NULL, $folderId);
			// Folders
			foreach($folders as $fold)
			{
				$content[] = array(
					'id' => $fold['id'],
					'name' => $fold['name'],
					'url' => $foldersURL . '?id=' . $fold['id'],
					'type' => 'folder',
					'lang_plan_type' => $lang['PLAN_FOLDER']
				);
			}
			// Plans
			foreach($plans as $plan)
			{
				$langTypeKey = "PLAN_TYPE_" . strtoupper($plan['type_name']);
				if(!isset($lang[$langTypeKey]))
				{
					$langTypeKey = "PLAN_TYPE_UNKNOWN";
				}

				$content[] = array(
					'id' => $plan['id'],
					'name' => $plan['name'],
					'url' => $apache_path . $plan['type_controller'] . '&id=' . $plan['id'],
					'type' => 'plan',
					'plan_type' => $plan['type_name'],
					'lang_plan_type' => $lang[$langTypeKey]
				);
			}

			echo json_encode($content);
			exit(0);
		}
		else
		{
			// strpos will return false if apache_path not found in current url. Else a number
			$isInPlanModule = strpos($_SERVER['SCRIPT_FILENAME'], $apache_path);
			
			// Init menu get the parents folders id to open the treeview to this plan or folder
			$parentsFolders = array();
			if($isInPlanModule != FALSE && !empty($_REQUEST['id']))
			{
				$elemId = intval($_REQUEST['id']);
				if($_REQUEST['action'] == 'plan' || $_REQUEST['action'] == 'admin')
				{
					// If it's a plan get its parent folder
					$plan = Model_plan::getPlans($dbconnection, $user->getId(), $elemId);
					$elemId = $plan[$elemId]['folders'];
				}
				// Get folder treeview
				if(!empty($elemId))
				{
					$parentsFolders = Model_plan::getFoldersTree($dbconnection, $user->getId(), $elemId);
					$parentsFolders = array_keys($parentsFolders);
				}
			}
			$smarty->assign('parentsFolders', json_encode($parentsFolders));

			$smarty->display($path . $apache_path . 'templates/menu_plan.html');
		}
	}
}
catch(\EsiaDbException | \Exception $e)
{
	// echo json_encode(array('error' => $e->getMessage()));
}
?>
